/* Tabela CONSSERV: Consumo Por Servio */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CONSSERV */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Consumo Por Servio,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_CONSSERV
AFTER DELETE OR INSERT OR UPDATE
ON CONSSERV FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_DSDIASEM  VARCHAR2(3);
  V_CDARVPROD VARCHAR2(20);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_DSDIASEM := '';
   V_CDARVPROD := '';

   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Filial=' || :OLD.CDFILIAL;
      END IF;
      IF :OLD.CDSERVFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' Serv=' || :OLD.CDSERVFILI;
      END IF;
      IF :OLD.IDQTDECONS IS NOT NULL THEN
         V_DESC := V_DESC || ' Tipo=' || :OLD.IDQTDECONS;
      END IF;
      IF :OLD.DTCONSSERV IS NOT NULL THEN
         V_DESC := V_DESC || ' DtValid=' || :OLD.DTCONSSERV;
      END IF;
      IF :OLD.IDTIPOCONS IS NOT NULL THEN
         IF :OLD.IDTIPOCONS = '1' THEN V_DSDIASEM := 'Dom'; END IF;
         IF :OLD.IDTIPOCONS = '2' THEN V_DSDIASEM := 'Seg'; END IF;
         IF :OLD.IDTIPOCONS = '3' THEN V_DSDIASEM := 'Ter'; END IF;
         IF :OLD.IDTIPOCONS = '4' THEN V_DSDIASEM := 'Qua'; END IF;
         IF :OLD.IDTIPOCONS = '5' THEN V_DSDIASEM := 'Qui'; END IF;
         IF :OLD.IDTIPOCONS = '6' THEN V_DSDIASEM := 'Sex'; END IF;
         IF :OLD.IDTIPOCONS = '7' THEN V_DSDIASEM := 'Sb'; END IF;
         IF :OLD.IDTIPOCONS = '8' THEN V_DSDIASEM := 'Fer'; END IF;
         IF :OLD.IDTIPOCONS = '9' THEN V_DSDIASEM := 'Exc'; END IF;

         V_DESC := V_DESC || ' Dia=' || V_DSDIASEM;
      END IF;
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF :OLD.QTCONSSERV IS NOT NULL THEN
         V_DESC := V_DESC || ' Qtde=' || :OLD.QTCONSSERV;
      END IF;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL||:OLD.CDSERVFILI||:OLD.IDQTDECONS||:OLD.IDTIPOCONS||TO_CHAR(:OLD.DTCONSSERV,'YYYYMMDD')||V_CDARVPROD;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL   <> :NEW.CDFILIAL)   OR
            (:OLD.CDSERVFILI <> :NEW.CDSERVFILI) OR
            (:OLD.IDQTDECONS <> :NEW.IDQTDECONS) OR
            (:OLD.IDTIPOCONS <> :NEW.IDTIPOCONS) OR
            (:OLD.DTCONSSERV <> :NEW.DTCONSSERV) OR
            (:OLD.CDPRODUTO  <> :NEW.CDPRODUTO)  OR
            (:OLD.QTCONSSERV <> :NEW.QTCONSSERV) THEN

            V_TIPO   := '2';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_ITPESQ := :OLD.CDFILIAL||:OLD.CDSERVFILI||:OLD.IDQTDECONS||:OLD.IDTIPOCONS||TO_CHAR(:OLD.DTCONSSERV,'YYYYMMDD')||V_CDARVPROD;
         END IF;
      ELSE
         V_TIPO   := '1';
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_ITPESQ := :NEW.CDFILIAL||:NEW.CDSERVFILI||:NEW.IDQTDECONS||:NEW.IDTIPOCONS||TO_CHAR(:NEW.DTCONSSERV,'YYYYMMDD')||V_CDARVPROD;
      END IF;

      IF :NEW.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Filial=' || :NEW.CDFILIAL;
      END IF;
      IF :NEW.CDSERVFILI IS NOT NULL THEN
         V_DESC := V_DESC || ' Serv=' || :NEW.CDSERVFILI;
      END IF;
      IF :NEW.IDQTDECONS IS NOT NULL THEN
         V_DESC := V_DESC || ' Tipo=' || :NEW.IDQTDECONS;
      END IF;
      IF :NEW.DTCONSSERV IS NOT NULL THEN
         V_DESC := V_DESC || ' DtValid=' || :NEW.DTCONSSERV;
      END IF;
      IF :NEW.IDTIPOCONS IS NOT NULL THEN
         IF :NEW.IDTIPOCONS = '1' THEN V_DSDIASEM := 'Dom'; END IF;
         IF :NEW.IDTIPOCONS = '2' THEN V_DSDIASEM := 'Seg'; END IF;
         IF :NEW.IDTIPOCONS = '3' THEN V_DSDIASEM := 'Ter'; END IF;
         IF :NEW.IDTIPOCONS = '4' THEN V_DSDIASEM := 'Qua'; END IF;
         IF :NEW.IDTIPOCONS = '5' THEN V_DSDIASEM := 'Qui'; END IF;
         IF :NEW.IDTIPOCONS = '6' THEN V_DSDIASEM := 'Sex'; END IF;
         IF :NEW.IDTIPOCONS = '7' THEN V_DSDIASEM := 'Sb'; END IF;
         IF :NEW.IDTIPOCONS = '8' THEN V_DSDIASEM := 'Fer'; END IF;
         IF :NEW.IDTIPOCONS = '9' THEN V_DSDIASEM := 'Exc'; END IF;

         V_DESC := V_DESC || ' Dia=' || V_DSDIASEM;
      END IF;
      IF :NEW.CDPRODUTO IS NOT NULL THEN
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF :NEW.QTCONSSERV IS NOT NULL THEN
         IF UPDATING THEN
            V_DESC := V_DESC || ' Qtde.de=' || :OLD.QTCONSSERV || ' para=' ||:NEW.QTCONSSERV;
         ELSE
            V_DESC := V_DESC || ' Qtde=' || :NEW.QTCONSSERV;
         END IF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CONSSERV',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LOG_PLA_CONSSERV','4.11.090'); END;
/

