/*
 Tecnisa - Tecnologia em Informtica

 Nome: Altera_Encaixe -  1069_FINSTP_ALTERA_TRAB_PREV.SQL

 Descrio:
 Grava os valores de cada dia de acordo com o parmetro passado.

 Criao:
 18/03/02 - Jenilson Ferreira

 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ALTERA_TRAB_PREV' AND
              TYPE   = 'P'               AND
              U.UID  = O.UID             AND
              U.NAME = USER)

DROP PROCEDURE ALTERA_TRAB_PREV
GO

CREATE PROCEDURE ALTERA_TRAB_PREV
   @P_CDFILIAL    VARCHAR(04),
   @P_NRPREVISAO  VARCHAR(10),
   @P_NRREGIPREV  VARCHAR(10),
   @P_NRCOLUNA    INTEGER,
   @P_DTDIAPREV   DATETIME,
   @P_VRDIAPREV   FLOAT

AS

BEGIN
   IF @P_NRCOLUNA = 1 BEGIN
      UPDATE TRAB_PREV
      SET
         DTDIA01PREV = @P_DTDIAPREV,
         VRDIA01PREV = @P_VRDIAPREV
      WHERE
         CDFILIPREV = @P_CDFILIAL    AND
         NRPREVISAO = @P_NRPREVISAO  AND
         NRREGIPREV = @P_NRREGIPREV;
   END
   ELSE BEGIN
      IF @P_NRCOLUNA = 2 BEGIN
         UPDATE TRAB_PREV
         SET
            DTDIA02PREV = @P_DTDIAPREV,
            VRDIA02PREV = @P_VRDIAPREV
         WHERE
            CDFILIPREV = @P_CDFILIAL    AND
            NRPREVISAO = @P_NRPREVISAO  AND
            NRREGIPREV = @P_NRREGIPREV;
      END
      ELSE BEGIN
         IF @P_NRCOLUNA = 3 BEGIN
            UPDATE TRAB_PREV
            SET
               DTDIA03PREV = @P_DTDIAPREV,
               VRDIA03PREV = @P_VRDIAPREV
            WHERE
               CDFILIPREV = @P_CDFILIAL   AND
               NRPREVISAO = @P_NRPREVISAO AND
               NRREGIPREV = @P_NRREGIPREV;
         END
         ELSE BEGIN
            IF @P_NRCOLUNA = 4 BEGIN
               UPDATE TRAB_PREV
               SET
                  DTDIA04PREV = @P_DTDIAPREV,
                  VRDIA04PREV = @P_VRDIAPREV
               WHERE
                  CDFILIPREV = @P_CDFILIAL   AND
                  NRPREVISAO = @P_NRPREVISAO AND
                  NRREGIPREV = @P_NRREGIPREV;
            END
            ELSE BEGIN
               IF @P_NRCOLUNA = 5 BEGIN
                  UPDATE TRAB_PREV
                  SET
                     DTDIA05PREV = @P_DTDIAPREV,
                     VRDIA05PREV = @P_VRDIAPREV
                  WHERE
                     CDFILIPREV = @P_CDFILIAL   AND
                     NRPREVISAO = @P_NRPREVISAO AND
                     NRREGIPREV = @P_NRREGIPREV;
               END
               ELSE BEGIN
                  IF @P_NRCOLUNA = 6 BEGIN
                     UPDATE TRAB_PREV
                     SET
                        DTDIA06PREV = @P_DTDIAPREV,
                        VRDIA06PREV = @P_VRDIAPREV
                     WHERE
                        CDFILIPREV = @P_CDFILIAL    AND
                        NRPREVISAO = @P_NRPREVISAO  AND
                        NRREGIPREV = @P_NRREGIPREV;
                  END;
               END;
            END;
         END;
      END;
   END;
END;
GO
